// Share the instance module in the next-shared layer
import { requestAsyncStorage } from './request-async-storage-instance' with {
    'turbopack-transition': 'next-shared'
};
import { cacheAsyncStorage } from '../../server/app-render/cache-async-storage.external';
export { requestAsyncStorage };
export function getExpectedRequestStore(callingExpression) {
    const store = requestAsyncStorage.getStore();
    if (store) return store;
    if (cacheAsyncStorage.getStore()) {
        throw new Error("`" + callingExpression + '` cannot be called inside "use cache". Call it outside and pass an argument instead. Read more: https://nextjs.org/docs/messages/next-request-in-use-cache');
    }
    throw new Error("`" + callingExpression + "` was called outside a request scope. Read more: https://nextjs.org/docs/messages/next-dynamic-api-wrong-context");
}

//# sourceMappingURL=request-async-storage.external.js.map