import type { ParsedUrlQuery } from 'querystring';
import type { AppRenderContext, GetDynamicParamFromSegment } from '../../server/app-render/app-render';
import type { LoaderTree } from '../../server/lib/app-dir-module';
import type { CreateServerParamsForMetadata } from '../../server/request/params';
import React from 'react';
import type { MetadataContext } from './types/resolvers';
import type { StaticGenerationStore } from '../../client/components/static-generation-async-storage.external';
export declare function createMetadataContext(pathname: string, renderOpts: AppRenderContext['renderOpts']): MetadataContext;
export declare function createTrackedMetadataContext(pathname: string, renderOpts: AppRenderContext['renderOpts'], staticGenerationStore: StaticGenerationStore | null): MetadataContext;
export declare function createMetadataComponents({ tree, searchParams, metadataContext, getDynamicParamFromSegment, appUsingSizeAdjustment, errorType, createServerParamsForMetadata, staticGenerationStore, }: {
    tree: LoaderTree;
    searchParams: Promise<ParsedUrlQuery>;
    metadataContext: MetadataContext;
    getDynamicParamFromSegment: GetDynamicParamFromSegment;
    appUsingSizeAdjustment: boolean;
    errorType?: 'not-found' | 'redirect';
    createServerParamsForMetadata: CreateServerParamsForMetadata;
    staticGenerationStore: StaticGenerationStore;
}): [React.ComponentType, () => Promise<void>];
