import { AsyncLocalStorage } from 'async_hooks';
export interface CacheScopeStore {
    cache?: Map<string, any>;
}
export declare const cacheScopeAsyncLocalStorage: AsyncLocalStorage<CacheScopeStore>;
/**
 * For dynamic IO handling we want to have a scoped memory
 * cache which can live either the lifetime of a build worker,
 * the lifetime of a specific request, or from a prefetch request
 * to the request for non-prefetch version of a page (with
 * drop-off after so long to prevent memory inflating)
 */
export declare function runWithCacheScope(store: Partial<CacheScopeStore>, fn: (...args: any[]) => Promise<any>): Promise<any>;
